Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/MetafileHeader.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/MetafileHeader.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/MetafileHeader.ab	(revision 698)
@@ -46,6 +46,5 @@
 Const GDIP_EMFPLUSFLAGS_DISPLAY      = &h00000001
 
-Class MetafileHeader
-Private
+Type MetafileHeader
 	mfType As MetafileType
 	Size As DWord
@@ -65,4 +64,5 @@
 	logicalDpiX As Long
 	logicalDpiY As Long
+/*
 Public
 	Function MetafileType() As MetafileType
@@ -91,6 +91,8 @@
 
 	Function Bounds() As Rectangle
-		Dim r(X, Y, Width, Height)
-		Return r
+		Bounds.X = X
+		Bounds.Y = Y
+		Bounds.Width = Width
+		Bounds.Height = Height
 	End Function
 
@@ -127,5 +129,5 @@
 	End Function
 
-	Function IsEmfPlusOnly() As BOOL /*const*/
+	Function IsEmfPlusOnly() As BOOL
 		IsEmfPlusOnly = (mfType = MetafileTypeEmfPlusOnly)
 	End Function
@@ -133,7 +135,8 @@
 	Function IsDisplay() As BOOL
 		If IsEmfPlus() <> FALSE And ((EmfPlusFlags And GDIP_EMFPLUSFLAGS_DISPLAY) <> 0) Then
-			IsDisplay = _System_TRUE
+			IsDisplay = TRUE
 		Else
-			IsDisplay = _System_FALSE
+			IsDisplay = FALSE
+		End If
 	End Function
 
@@ -146,5 +149,5 @@
 	End Function
 
-	Function GetEmfHeader() As * /*const*/ ENHMETAHEADER3 /*const*/
+	Function GetEmfHeader() As *ENHMETAHEADER3
 		If IsEmfOrEmfPlus() Then
 			Return VarPtr(EmfHeader) 'VarPtr(WmfHeader)
@@ -153,5 +156,6 @@
 		End If
 	End Function
-End Class
+*/
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab	(revision 698)
@@ -1,10 +1,10 @@
 ' Classes/System/Drawing/Imaging/misc.ab
+
+TypeDef ARGB = DWord
+TypeDef ARGB64 = QWord
 
 Namespace System
 Namespace Drawing
 Namespace Imaging
-
-TypeDef ARGB = DWord
-TypeDef ARGB64 = QWord
 
 Enum ColorMode
@@ -137,5 +137,5 @@
 Type Align(8) EncoderParameters
 	Count As DWord
-	Parameter[1] As EncoderParameter
+	Parameter[0] As EncoderParameter
 End Type
 
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Pen.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Pen.ab	(revision 698)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Pen.ab	(revision 698)
@@ -0,0 +1,277 @@
+' Classes/System/Drawing/Pen.ab
+
+Namespace System
+Namespace Drawing
+
+Namespace Drawing2D
+Class CustomLineCap
+Public 
+	Function NativeCap() As *GpCustomLineCap
+	End Function
+End Class
+End Namespace
+
+Class Pen
+	Implements IDisposable, ICloneable
+Public
+	Sub Pen(native As *GpPen)
+		nativePen = native
+	End Sub
+
+	Sub Pen(color As Color, width = 1.0 As Single)
+		SetStatus(GdipCreatePen1(color, width, 0 /*GraphicsUnit.World As GpUnit*/, nativePen))
+	End Sub
+
+	Sub Pen(brush As Brush, width = 1.0 As Single)
+		If ActiveBasic.IsNothing(brush) Then
+			Throw New ArgumentNullException("brush")
+		End If
+		SetStatus(GdipCreatePen2(brush.nativeBrush, width, 0 /*GraphicsUnit.World As GpUnit*/, nativePen))
+	End Sub
+
+	Sub Dispose()
+		If nativePen <> 0 Then
+			GdipDeletePen(nativePen)
+		End If
+		nativePen = 0
+	End Sub
+
+	Sub ~Pen()
+		Dispose()
+	End Sub
+
+	Function Clone() As Pen
+		Dim cloned As *GpPen
+		SetStatus(GdipClonePen(nativePen, cloned))
+		Clone = New Pen(cloned)
+	End Function
+
+	Function NativePen() As *GpPen
+		NativePen = nativePen
+	End Function
+
+	'=========================================================================
+	' Properties
+	'=========================================================================
+
+	Sub Width(width As Single)
+		SetStatus(GdipSetPenWidth(nativePen, width))
+	End Sub
+
+	Function Width() As Single
+        SetStatus(GdipGetPenWidth(nativePen, Width))
+	End Function
+
+	Sub StartCap(cap As Drawing2D.LineCap)
+		SetStatus(GdipSetPenStartCap(nativePen, cap))
+	End Sub
+/*
+	Function StartCap() As Drawing2D.LineCap
+        SetStatus(GdipGetPenStartCap(nativePen, StartCap))
+	End Function
+*/
+	Sub EndCap(cap As Drawing2D.LineCap)
+		SetStatus(GdipSetPenEndCap(nativePen, cap))
+	End Sub
+/*
+	Function EndCap() As Drawing2D.LineCap
+        SetStatus(GdipGetPenEndCap(nativePen, EndCap))
+	End Function
+*/
+	Sub DashCap(cap As Drawing2D.DashCap)
+		SetStatus(GdipSetPenDashCap197819(nativePen, cap))
+	End Sub
+/*
+	Function DashCap() As Drawing2D.DashCap
+        SetStatus(GdipGetPenDashCap197819(nativePen, DashCap))
+	End Function
+*/
+	Sub LineJoin(lineJoin As Drawing2D.LineJoin)
+		SetStatus(GdipSetPenLineJoin(nativePen, lineJoin))
+	End Sub
+/*
+	Function LineJoin() As Drawing2D.LineJoin
+        SetStatus(GdipGetPenLineJoin(nativePen, LineJoin))
+	End Function
+*/
+	Sub CustomStartCap(cap As Drawing2D.CustomLineCap)
+		SetStatus(GdipSetPenCustomStartCap(nativePen, getNativeCustomCap(cap)))
+	End Sub
+/*
+	Function CustomStartCap() As Drawing2D.CustomLineCap
+		Dim native As *GpCustomLineCap
+        SetStatus(GdipGetPenCustomStartCap(nativePen, native))
+		CustomStartCap = New Drawing2D.CustomStartCap(native)
+	End Function
+*/
+	Sub CustomEndCap(cap As Drawing2D.CustomLineCap)
+		SetStatus(GdipSetPenCustomEndCap(nativePen, getNativeCustomCap(cap)))
+	End Sub
+/*
+	Function CustomEndCap() As Drawing2D.CustomLineCap
+		Dim nativeCustomCap As *GpCustomLineCap
+        SetStatus(GdipGetPenCustomEndCap(nativePen, nativeCustomCap))
+		CustomStartCap = New CustomStartCap(nativeCustomCap)
+	End Function
+*/
+	Sub MiterLimit(miterLimit As Single)
+		SetStatus(GdipSetPenMiterLimit(nativePen, miterLimit))
+	End Sub
+
+	Function MiterLimit() As Single
+        SetStatus(GdipGetPenMiterLimit(nativePen, MiterLimit))
+	End Function
+
+	Sub Alignment(alignment As Drawing2D.PenAlignment)
+		SetStatus(GdipSetPenMode(nativePen, alignment))
+	End Sub
+/*
+	Function Alignment() As Drawing2D.PenAlignment
+        SetStatus(GdipGetPenMode(nativePen, Alignment))
+	End Function
+*/
+	Sub Transform(m As Drawing2D.Matrix)
+		SetStatus(GdipSetPenTransform(nativePen, m.NativeMatrix))
+	End Sub
+
+	Function Transform() As Drawing2D.Matrix
+		Dim native As *GpMatrix
+        SetStatus(GdipGetPenTransform(nativePen, native))
+		Transform = New Matrix(native)
+	End Function
+/*
+	Function PenType() As Drawing2D.PenType
+		SetStatus(GdipGetPenFillType(nativePen, PenType))
+	End Function
+*/
+	Sub Color(color As Color)
+		SetStatus(GdipSetPenColor(nativePen, color))
+	End Sub
+/*
+	Function Color() As Color
+		If This.PenType <> Drawing2D.PenType.SolidColor Then
+			SetStatus(State.WrongState)
+		End If
+		SetStatus(GdipGetPenColor(nativePen, Color))
+	End Function
+*/
+	Sub Brush(brush As Brush)
+		SetStatus(GdipSetPenBrushFill(nativePen, getNativeBrush(brush)))
+	End Sub
+/*
+	Function Brush() As Brush
+		Imports Drawing2D
+		Dim penType = PenType
+		Dim native As *GpBrush
+		Select Case penType
+			Case PenType.SolidColor
+				SetStatus(GdipGetPenBrushFill(nativePen, native))
+				Brush = New SolidBrush(native)
+			Case PenType.HatchFill
+				SetStatus(GdipGetPenBrushFill(nativePen, native))
+				Brush = New HatchBrush(native)
+			Case PenType.TextureFill
+				SetStatus(GdipGetPenBrushFill(nativePen, native))
+				Brush = New TextureBrush(native)
+			Case PenType.Gradient
+				SetStatus(GdipGetPenBrushFill(nativePen, native))
+				Brush = New Brush(native)
+			Case PenType.LinearGradient
+				SetStatus(GdipGetPenBrushFill(nativePen, native))
+				Brush = New LinearGradientBrush(native)
+			Case Else
+				Brush = Nothing
+		End Select
+	End Function
+*/
+	Sub DashStyle(dashStyle As Drawing2D.DashStyle)
+		SetStatus(GdipSetPenDashStyle(nativePen, dashStyle))
+	End Sub
+/*
+	Function DashStyle() As Drawing2D.DashStyle
+        SetStatus(GdipGetPenDashStyle(nativePen, DashStyle))
+	End Function
+*/
+	Sub DashOffset(dashOffset As Single)
+		SetStatus(GdipSetPenDashOffset(nativePen, dashOffset))
+	End Sub
+
+	Function DashOffset() As Single
+        SetStatus(GdipGetPenDashOffset(nativePen, DashOffset))
+	End Function
+
+	'DashPattern
+	'CompoundArray
+
+	'=========================================================================
+	' Functions
+	'=========================================================================
+
+	Sub SetLineCap(startCap As Drawing2D.LineCap, endCap As Drawing2D.LineCap, dashCap As Drawing2D.DashCap)
+        SetStatus(GdipSetPenLineCap197819(nativePen, startCap, endCap, dashCap))
+	End Sub
+
+	Sub ResetTransform()
+		SetStatus(GdipResetPenTransform(nativePen))
+	End Sub
+
+	Sub MultiplyTransform(m As Drawing2D.Matrix)
+		Imports System.Drawing.Drawing2D
+		MultiplyTransform(m, MatrixOrder.Prepend)
+	End Sub
+
+	Sub MultiplyTransform(m As Drawing2D.Matrix, order As Drawing2D.MatrixOrder)
+		SetStatus(GdipMultiplyPenTransform(nativePen, m.nativeMatrix, order))
+	End Sub
+
+	Sub TranslateTransform(dx As Single, dy As Single)
+		Imports System.Drawing.Drawing2D
+		TranslateTransform(dx, dy, MatrixOrder.Prepend)
+	End Sub
+
+	Sub TranslateTransform(dx As Single, dy As Single, order As Drawing2D.MatrixOrder)
+		SetStatus(GdipTranslatePenTransform(nativePen, dx, dy, order))
+	End Sub
+
+	Sub ScaleTransform(sx As Single, sy As Single)
+		Imports System.Drawing.Drawing2D
+		ScaleTransform(sx, sy, MatrixOrder.Prepend)
+	End Sub
+
+	Sub ScaleTransform(sx As Single, sy As Single, order As Drawing2D.MatrixOrder)
+		SetStatus(GdipScalePenTransform(nativePen, sx, sy, order))
+	End Sub
+
+	Sub RotateTransform(angle As Single)
+		Imports System.Drawing.Drawing2D
+		RotateTransform(angle, MatrixOrder.Prepend)
+	End Sub
+
+	Sub RotateTransform(angle As Single, order As Drawing2D.MatrixOrder)
+		SetStatus(GdipRotatePenTransform(nativePen, angle, order))
+	End Sub
+
+Private
+
+	nativePen As *GpPen
+
+	Static Function getNativeCustomCap(cap As Drawing2D.CustomLineCap) As *GpCustomLineCap
+		If ActiveBasic.IsNothing(cap) Then
+			getNativeCustomCap = 0
+		Else
+			getNativeCustomCap = cap.NativeCap
+		End If
+	End Function
+
+	Static Function getNativeBrush(br As Brush) As *GpBrush
+		If ActiveBasic.IsNothing(br) Then
+			getNativeBrush = 0
+		Else
+			getNativeBrush = br.nativeBrush
+		End If
+	End Function
+
+End Class
+
+End Namespace
+End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Point.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Point.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Point.ab	(revision 698)
@@ -4,123 +4,8 @@
 Namespace Drawing
 
-Class Point
-Public
-	Sub Point()
-		x = 0
-		y = 0
-	End Sub
-
-	Sub Point(initX As Long, initY As Long)
-		x = initX
-		y = initY
-	End Sub
-
-	Sub Point(sz As Size)
-		x = sz.Width
-		y = sz.Height
-	End Sub
-
-	Sub Point(dw As DWord)
-		x = LOWORD(dw)
-		y = HIWORD(dw)
-	End Sub
-
-	Function X() As Long
-		X = x
-	End Function
-
-	Sub X(newX As Long)
-		x = newX
-	End Sub
-
-	Function Y() As Long
-		Y = y
-	End Function
-
-	Sub Y(newY As Long)
-		y = newY
-	End Sub
-
-	Function IsEmpty() As Boolean
-		Return x = 0 And y = 0
-	End Function
-
-	Function Operator +(pt As Point) As Point
-		Return Add(This, pt)
-	End Function
-
-	Function Operator +(sz As Size) As Point
-		Return Add(This, sz)
-	End Function
-
-	Function Operator -(pt As Point) As Point
-		Return Substract(This, pt)
-	End Function
-
-	Function Operator -(sz As Size) As Point
-		Return Substract(This, sz)
-	End Function
-
-	Function Operator ==(sz As Point) As Boolean
-		Return Equals(sz)
-	End Function
-
-	Function Operator <>(sz As Point) As Boolean
-		Return Not Equals(sz)
-	End Function
-
-	Static Function Add(pt1 As Point, pt2 As Point) As Point
-		Return New Point(pt1.x + pt2.x, pt1.y + pt2.y)
-	End Function
-
-	Static Function Add(pt As Point, sz As Size) As Point
-		Return New Point(pt.x + sz.Width, pt.y + sz.Height)
-	End Function
-
-	Function Offset(pt As Point) As Point
-		Return New Point(x + pt.x, y + pt.y)
-	End Function
-
-	Sub Offset(dx As Long, dy As Long)
-		x += dx
-		y += dy
-	End Sub
-
-	Static Function Substract(pt1 As Point, pt2 As Point) As Point
-		Return New Point(pt1.x - pt2.x, pt1.y - pt2.y)
-	End Function
-
-	Static Function Substract(pt As Point, sz As Size) As Point
-		Return New Point(pt.x - sz.Width, pt.y - sz.Height)
-	End Function
-
-	Function Equals(pt As Point) As Boolean
-		Return x = pt.x And y = pt.y
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return x Xor _System_BSwap(y As DWord)
-	End Function
-
-	Static Function Ceiling(ptf As PointF) As Point
-		Return New Point(Math.Ceiling(ptf.X) As Long, Math.Ceiling(ptf.Y) As Long)
-	End Function
-
-	Static Function Round(ptf As PointF) As Point
-		Return New Point(Math.Round(ptf.X) As Long, Math.Round(ptf.Y) As Long)
-	End Function
-
-	Static Function Truncate(ptf As PointF) As Point
-		Return New Point(Math.Truncate(ptf.X) As Long, Math.Truncate(ptf.Y) As Long)
-	End Function
-
-	Function Operator () As PointF
-		Return New PointF(X, Y)
-	End Function
-
-Private
-	x As Long
-	y As Long
-End Class
+Type Point
+	X As Long
+	Y As Long
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/PointF.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/PointF.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/PointF.ab	(revision 698)
@@ -4,114 +4,8 @@
 Namespace Drawing
 
-Class PointF
-Public
-	Sub PointF()
-		x = 0
-		y = 0
-	End Sub
-
-	Sub PointF(initX As Single, initY As Single)
-		x = initX
-		y = initY
-	End Sub
-
-	Sub PointF(pt As PointF)
-		x = pt.x
-		y = pt.y
-	End Sub
-
-	Sub PointF(sz As SizeF)
-		x = sz.Width
-		y = sz.Height
-	End Sub
-
-	Function X() As Single
-		X = x
-	End Function
-
-	Sub X(newX As Single)
-		x = newX
-	End Sub
-
-	Function Y() As Single
-		Y = y
-	End Function
-
-	Sub Y(newY As Single)
-		y = newY
-	End Sub
-
-	Function IsEmpty() As Boolean
-		Return x = 0 And y = 0
-	End Function
-
-	Function Operator + (pt As PointF) As PointF
-		Return Add(This, pt)
-	End Function
-
-	Function Operator + (sz As Size) As PointF
-		Return Add(This, sz)
-	End Function
-
-	Function Operator + (sz As SizeF) As PointF
-		Return Add(This, sz)
-	End Function
-
-	Function Operator - (pt As PointF) As PointF
-		Return Substract(This, pt)
-	End Function
-
-	Function Operator - (sz As Size) As PointF
-		Return Substract(This, sz)
-	End Function
-
-	Function Operator - (sz As SizeF) As PointF
-		Return Substract(This, sz)
-	End Function
-
-	Function Operator == (sz As PointF) As Boolean
-		Return Equals(sz)
-	End Function
-
-	Function Operator <> (sz As PointF) As Boolean
-		Return Not Equals(sz)
-	End Function
-
-	Static Function Add(pt1 As PointF, pt2 As PointF) As PointF
-		Return New PointF(pt1.x + pt2.x, pt1.y + pt2.y)
-	End Function
-
-	Static Function Add(pt As PointF, sz As Size) As PointF
-		Return New PointF(pt.x + sz.Width, pt.y + sz.Height)
-	End Function
-
-	Static Function Add(pt As PointF, sz As SizeF) As PointF
-		Return New PointF(pt.x + sz.Width, pt.y + sz.Height)
-	End Function
-
-	Static Function Substract(pt1 As PointF, pt2 As PointF) As PointF
-		Return New PointF(pt1.x - pt2.x, pt1.y - pt2.y)
-	End Function
-
-	Static Function Substract(pt As PointF, sz As Size) As PointF
-		Return New PointF(pt.x - sz.Width, pt.y - sz.Height)
-	End Function
-
-	Static Function Substract(pt As PointF, sz As SizeF) As PointF
-		Return New PointF(pt.x - sz.Width, pt.y - sz.Height)
-	End Function
-
-	Function Equals(pt As PointF) As Boolean
-		Return x = pt.x And y = pt.y
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return (GetDWord(VarPtr(x)) Xor _System_BSwap(GetDWord(VarPtr(x)))) As Long
-	End Function
-
-Private
-	x As Single
-	y As Single
-End Class
+Type PointF
+	X As Single
+	Y As Single
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Rectangle.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Rectangle.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Rectangle.ab	(revision 698)
@@ -4,240 +4,10 @@
 Namespace Drawing
 
-Class Rectangle
-Public
-	Sub Rectangle()
-		x = 0
-		y = 0
-		width = 0
-		height = 0
-	End Sub
-
-	Sub Rectangle(x As Long, y As Long, width As Long, height As Long)
-		x = x
-		y = y
-		width = width
-		height = height
-	End Sub
-
-	Sub Rectangle(l As Point, s As Size)
-		x = l.X
-		y = l.Y
-		width = s.Height
-		height = s.Height
-	End Sub
-
-	Sub Rectangle(ByRef r As RECT)
-		x = r.left
-		y = r.top
-		width = r.right - r.left
-		height = r.top - r.bottom
-	End Sub
-
-	Function Location() As Point
-		Location = New Point(x, y)
-	End Function
-
-	Sub Location(point As Point)
-		x = point.X
-		y = point.Y
-	End Sub
-
-	Function Size() As Size
-		Size = New Size(width, height)
-	End Function
-
-	Sub Size(size As Size)
-		width = size.Width
-		height = size.Height
-	End Sub
-
-	Function X() As Long
-		X = x
-	End Function
-
-	Sub X(value As Long)
-		x = value
-	End Sub
-
-	Function Y() As Long
-		Y = y
-	End Function
-
-	Sub Y(value As Long)
-		y = value
-	End Sub
-
-	Function Width() As Long
-		Width = width
-	End Function
-
-	Sub Width(value As Long)
-		width = value
-	End Sub
-
-	Function Height() As Long
-		Height = height
-	End Function
-
-	Sub Height(value As Long)
-		height = value
-	End Sub
-
-	Function Left() As Long
-		Left = X
-	End Function
-
-	Function Top() As Long
-		Top = Y
-	End Function
-
-	Function Right() As Long
-		Right = X + Width
-	End Function
-
-	Function Bottom() As Long
-		Bottom = Y + Height
-	End Function
-
-	Function IsEmpty() As Boolean
-		Return Width <= 0 Or Height <= 0
-	End Function
-
-	Function Operator ==(rc As Rectangle) As Boolean
-		Return Equals(rc)
-	End Function
-
-	Function Operator <>(rc As Rectangle) As Boolean
-		Return (Not Equals(rc))
-	End Function
-
-	Function Operator () As RectangleF
-		Return New RectangleF(x, y, width, height)
-	End Function
-
-	Function Equals(rc As Rectangle) As Boolean
-		Return X = rc.X And Y = rc.Y And Width = rc.Width And Height = rc.Height
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return x As DWord Xor _System_BSwap(y As DWord) Xor width As DWord Xor _System_BSwap(height As DWord)
-	End Function
-
-	Static Function FromLTRB(l As Long, t As Long, r As Long, b As Long) As Rectangle
-		return New Rectangle(l, t, r - l, b - t)
-	End Function
-
-	Function Contains(x As Long, y As Long) As Boolean
-		Return x >= X And x < X + Width And y >= Y And y < Y + Height
-	End Function
-
-	Function Contains(pt As Point) As Boolean
-		Return Contains(pt.X, pt.Y)
-	End Function
-
-	Function Contains(rc As Rectangle) As Boolean
-		Return X <= rc.X And rc.Right <= Right And Y <= rc.Y And rc.Bottom <= Bottom
-	End Function
-
-	Sub Inflate(dx As Long, dy As Long)
-		x -= dx
-		y -= dy
-		width += dx + dx
-		height += dy + dy
-	End Sub
-
-	Sub Inflate(sz As Size)
-		Inflate(sz.Width, sz.Height)
-	End Sub
-
-	Static Function Inflate(rc As Rectangle, x As Long, y As Long) As Rectangle
-		Inflate = New Rectangle(rc.X, rc.Y, rc.Width, rc.Height)
-		Inflate.Inflate(x, y)
-	End Function
-
-	Sub Intersect(rect As Rectangle)
-		Dim r = Rectangle.Intersect(This, rect)
-		x = r.x
-		y = r.y
-		width = r.width
-		height = r.height
-	End Sub
-
-	Static Function Intersect(a As Rectangle, ByRef b As Rectangle) As Rectangle
-		Dim right As Long, bottom As Long, left As Long, top As Long
-		right = System.Math.Min(a.Right, b.Right)
-		bottom = System.Math.Min(a.Bottom, b.Bottom)
-		left = System.Math.Min(a.Left, b.Left)
-		top = System.Math.Min(a.Top, b.Top)
-		Return Rectangle.FromLTRB(left, top, right, bottom)
-	End Function
-
-	Function IntersectsWith(rc As Rectangle) As Boolean
-		Return Left < rc.Right And _
-			Top < rc.Bottom And _
-			Right > rc.Left And _
-			Bottom > rc.Top
-	End Function
-
-	Static Function Union(a As Rectangle, b As Rectangle) As Rectangle
-		Dim right As Long, bottom As Long, left As Long, top As Long
-		right = System.Math.Max(a.Right(), b.Right())
-		bottom = System.Math.Max(a.Bottom(), b.Bottom())
-		left = System.Math.Max(a.Left(), b.Left())
-		top = System.Math.Max(a.Top(), b.Top())
-		Return FromLTRB(left, top, right, bottom)
-	End Function
-
-	Sub Offset(pt As Point)
-		Offset(pt.X, pt.Y)
-	End Sub
-
-	Sub Offset(dx As Long, dy As Long)
-		x += dx
-		y += dy
-	End Sub
-
-	Static Function Ceiling(rcf As RectangleF) As Rectangle
-		Dim r As Rectangle(
-			Math.Ceiling(rcf.X) As Long,
-			Math.Ceiling(rcf.Y) As Long,
-			Math.Ceiling(rcf.Width) As Long,
-			Math.Ceiling(rcf.Height) As Long)
-		Return r
-	End Function
-
-	Static Function Round(rcf As RectangleF) As Rectangle
-		Dim r As Rectangle(
-			Math.Round(rcf.X) As Long,
-			Math.Round(rcf.Y) As Long,
-			Math.Round(rcf.Width) As Long,
-			Math.Round(rcf.Height) As Long)
-		Return r
-	End Function
-
-	Static Function Truncate(rcf As RectangleF) As Rectangle
-		Dim r As Rectangle(
-			Math.Truncate(rcf.X) As Long,
-			Math.Truncate(rcf.Y) As Long,
-			Math.Truncate(rcf.Width) As Long,
-			Math.Truncate(rcf.Height) As Long)
-		Return r
-	End Function
-
-	Function ToRECT() As RECT
-		With ToRECT
-			.left = x
-			.top = y
-			.right = x + width
-			.bottom = y + height
-		End With
-	End Function
-
-Public
-	x As Long
-	y As Long
-	width As Long
-	height As Long
-End Class
+Type Rectangle
+	X As Long
+	Y As Long
+	Width As Long
+	Height As Long
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/RectangleF.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/RectangleF.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/RectangleF.ab	(revision 698)
@@ -4,204 +4,10 @@
 Namespace Drawing
 
-Class RectangleF
-Public
-	Sub RectangleF()
-		x = 0
-		y = 0
-		width = 0
-		height = 0
-	End Sub
-
-	Sub RectangleF(x As Single, y As Single, width As Single, height As Single)
-		x = x
-		y = y
-		width = width
-		height = height
-	End Sub
-
-	Sub RectangleF(location As PointF, size As SizeF)
-		x = location.X
-		y = location.Y
-		width = size.Height
-		height = size.Height
-	End Sub
-
-	Sub RectangleF(rc As RectangleF)
-		x = rc.x
-		y = rc.y
-		width = rc.width
-		height = rc.height
-	End Sub
-
-	Function Location() As PointF
-		Location = New PointF(x, y)
-	End Function
-
-	Sub Location(point As PointF)
-		x = point.X
-		y = point.Y
-	End Sub
-
-	Function Size() As SizeF
-		Size = New SizeF(width, height)
-	End Function
-
-	Sub Size(size As SizeF)
-		width = size.Width
-		height = size.Height
-	End Sub
-
-	Function X() As Single
-		X = x
-	End Function
-
-	Sub X(value As Single)
-		x = value
-	End Sub
-
-	Function Y() As Single
-		Y = y
-	End Function
-
-	Sub Y(value As Single)
-		y = value
-	End Sub
-
-	Function Width() As Single
-		Width = width
-	End Function
-
-	Sub Width(value As Single)
-		width = value
-	End Sub
-
-	Function Height() As Single
-		Height = height
-	End Function
-
-	Sub Height(value As Single)
-		height = value
-	End Sub
-
-	Function Left() As Single
-		Left = X
-	End Function
-
-	Function Top() As Single
-		Top = Y
-	End Function
-
-	Function Right() As Single
-		Right = X + Width
-	End Function
-
-	Function Bottom() As Single
-		Bottom = Y + Height
-	End Function
-
-	Function IsEmpty() As Boolean
-		Return Width <= 0 Or Height <= 0
-	End Function
-
-	Function Operator ==(rc As RectangleF) As Boolean
-		Return Equals(rc)
-	End Function
-
-	Function Operator <>(rc As RectangleF) As Boolean
-		Return Not Equals(rc)
-	End Function
-
-	Function Equals(rc As RectangleF) As Boolean
-		Equals = (X = rc.X And Y = rc.Y And Width = rc.Width And Height = rc.Height)
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return GetDWord(VarPtr(x)) Xor _System_BSwap(GetDWord(VarPtr(y))) Xor GetDWord(VarPtr(width)) Xor _System_BSwap(GetDWord(VarPtr(height)))
-	End Function
-
-	Static Function FromLTRB(l As Single, t As Single, r As Single, b As Single) As RectangleF
-		return New RectangleF(l, t, r - l, b - t)
-	End Function
-
-	Function Contains(x As Single, y As Single) As Boolean
-		Contains = (x >= X And x < X + Width And y >= Y And y < Y + Height)
-	End Function
-
-	Function Contains(pt As PointF) As Boolean
-		Return Contains(pt.X, pt.Y)
-	End Function
-
-	Function Contains(rc As RectangleF) As Boolean
-		Contains = (X <= rc.X And rc.Right <= Right And Y <= rc.Y And rc.Bottom <= Bottom)
-	End Function
-
-	Sub Inflate(dx As Single, dy As Single)
-		x -= dx
-		y -= dy
-		width += dx + dx
-		height += dy + dy
-	End Sub
-
-	Sub Inflate(sz As SizeF)
-		Inflate(sz.Width, sz.Height)
-	End Sub
-
-	Static Function Inflate(rc As RectangleF, x As Single, y As Single) As RectangleF
-		Inflate = New RectangleF(rc.X, rc.Y, rc.Width, rc.Height)
-		Inflate.Inflate(x, y)
-	End Function
-
-	Sub Intersect(rect As RectangleF)
-		Dim r = RectangleF.Intersect(This, rect)
-		x = r.x
-		y = r.y
-		width = r.width
-		height = r.height
-	End Sub
-	
-	Static Function Intersect(a As RectangleF, b As RectangleF) As RectangleF
-		Dim right As Single, bottom As Single, left As Single, top As Single
-		right = System.Math.Min(a.Right, b.Right)
-		bottom = System.Math.Min(a.Bottom, b.Bottom)
-		left = System.Math.Min(a.Left, b.Left)
-		top = System.Math.Min(a.Top, b.Top)
-		Return FromLTRB(left, top, right, bottom)
-	End Function
-
-	Function IntersectsWith(rc As RectangleF) As Boolean
-		If Left < rc.Right And _
-			Top < rc.Bottom And _
-			Right > rc.Left And _
-			Bottom > rc.Top Then
-			IntersectsWith = True
-		Else
-			IntersectsWith = False
-		End If
-	End Function
-
-	Static Function Union(a As RectangleF, b As RectangleF) As RectangleF
-		Dim right As Single, bottom As Single, left As Single, top As Single
-		right = System.Math.Max(a.Right(), b.Right())
-		bottom = System.Math.Max(a.Bottom(), b.Bottom())
-		left = System.Math.Max(a.Left(), b.Left())
-		top = System.Math.Max(a.Top(), b.Top())
-		Return FromLTRB(left, top, right, bottom)
-	End Function
-
-	Sub Offset(pt As PointF)
-		Offset(pt.X, pt.Y)
-	End Sub
-
-	Sub Offset(dx As Single, dy As Single)
-		x += dx
-		y += dy
-	End Sub
-
-Public
-	x As Single
-	y As Single
-	width As Single
-	height As Single
-End Class
+Type RectangleF
+	X As Single
+	Y As Single
+	Width As Single
+	Height As Single
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Size.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Size.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Size.ab	(revision 698)
@@ -4,97 +4,8 @@
 Namespace Drawing
 
-Class Size
-Public
-	Sub Size()
-		width = 0
-		height = 0
-	End Sub
-
-	Sub Size(initWidth As Long, initHeight As Long)
-		width = initWidth
-		height = initHeight
-	End Sub
-
-	Sub Size(sz As Size)
-		width = sz.width
-		height = sz.height
-	End Sub
-
-	Function Width() As Long
-		Return width
-	End Function
-
-	Sub Width(w As Long)
-		width = w
-	End Sub
-
-	Function Height() As Long
-		Return height
-	End Function
-
-	Sub Height(h As Long)
-		height = h
-	End Sub
-
-	Function Operator +(sz As Size) As Size
-		Return New Size(width + sz.width, height + sz.height)
-	End Function
-
-	Function Operator -(sz As Size) As Size
-		Return New Size(width - sz.width, height - sz.height)
-	End Function
-
-	Function Operator () As SizeF
-		Return New SizeF(width, height)
-	End Function
-
-	Function Operator ==(sz As Size) As Boolean
-		Return Equals(sz)
-	End Function
-
-	Function Operator <>(sz As Size) As Boolean
-		Return Not Equals(sz)
-	End Function
-
-	Function Equals(sz As Size) As Boolean
-		If width = sz.width And height = sz.height Then
-			Equals = True
-		Else
-			Equals = False
-		End If
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return width As DWord Xor _System_BSwap(height As DWord)
-	End Function
-
-	Function IsEmpty() As Boolean
-		Return width = 0 And height = 0
-	End Function
-
-	Function Add(sz As Size) As Size
-		Return This + sz
-	End Function
-
-	Function Subtract(sz As Size) As Size
-		Return This - sz
-	End Function
-
-	Static Function Ceiling(szf As SizeF) As Size
-		Return New Size(System.Math.Ceiling(szf.Width) As Long, System.Math.Ceiling(szf.Height) As Long)
-	End Function
-
-	Static Function Round(szf As SizeF) As Size
-		Return New Size(System.Math.Round(szf.Width) As Long, System.Math.Round(szf.Height) As Long)
-	End Function
-
-	Static Function Truncate(szf As SizeF) As Size
-		Return New Size(System.Math.Truncate(szf.Width) As Long, System.Math.Truncate(szf.Height) As Long)
-	End Function
-
-Private
-	width As Long
-	height As Long
-End Class
+Type Size
+	Width As Long
+	Height As Long
+End Type
 
 End Namespace
Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/SizeF.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/SizeF.ab	(revision 695)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/SizeF.ab	(revision 698)
@@ -4,84 +4,8 @@
 Namespace Drawing
 
-Class SizeF
-Public
-	Sub SizeF()
-		width = 0
-		height = 0
-	End Sub
-
-	Sub SizeF(initWidth As Single, initHeight As Single)
-		width = initWidth
-		height = initHeight
-	End Sub
-
-	Sub SizeF(sz As SizeF)
-		width = sz.width
-		height = sz.height
-	End Sub
-
-	Function Width() As Single
-		Return width
-	End Function
-
-	Sub Width(w As Single)
-		width = w
-	End Sub
-
-	Function Height() As Single
-		Return height
-	End Function
-
-	Sub Height(h As Single)
-		height = h
-	End Sub
-
-	Function Operator +(sz As SizeF) As SizeF
-		Return New SizeF(width + sz.width, height + sz.height)
-	End Function
-
-	Function Operator -(sz As SizeF) As SizeF
-		Return New SizeF(width - sz.width, height - sz.height)
-	End Function
-
-	Function Operator ==(sz As SizeF) As Boolean
-		Return Equals(sz)
-	End Function
-
-	Function Operator <>(sz As SizeF) As Boolean
-		Return Not Equals(sz)
-	End Function
-
-	Function Equals(sz As SizeF) As Boolean
-		Return width = sz.width And height = sz.height
-	End Function
-
-	Override Function GetHashCode() As Long
-		Return GetDWord(VarPtr(width)) Xor _System_BSwap(GetDWord(VarPtr(height)))
-	End Function
-
-	Function IsEmpty() As Boolean
-		Return width = 0 And height = 0
-	End Function
-
-	Function Add(sz As SizeF) As SizeF
-		Return This + sz
-	End Function
-
-	Function Subtract(sz As SizeF) As SizeF
-		Return This - sz
-	End Function
-
-	Function ToSize() As Size
-		Return Size.Round(This)
-	End Function
-
-	Function ToPointF() As PointF
-		Return New PointF(width, height)
-	End Function
-Private
-	width As Single
-	height As Single
-End Class
+Type SizeF
+	Width As Single
+	Height As Single
+End Type
 
 End Namespace
